Trace all events in React ListView component

23 Jan 202514 minutes to read

The ListView component triggers events based on its actions. These events can be used as extension points to perform custom operations. Refer to the following steps to trace the ListView events:

  1. Render the ListView with dataSource, and bind the actionBegin, actionComplete, and select events.

  2. Perform custom operations in actionBegin, actionComplete, and select events.

  3. Provide event log details for actionBegin and actionComplete events. These will be displayed in the event trace panel when the ListView action starts and the dataSource is bound successfully.

  4. Get the selected item details from the SelectEventArgs in the select event, and display the selected list item text in the event trace panel while selecting list items.

  5. Use the clear button to remove event trace information.

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import './index.css';
function App() {
  //Define an array of JSON data
  let data = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" },
    { text: "Aston Martin One- 77", id: "list-07" },
    { text: "Jaguar XJ220", id: "list-08" },
    { text: "McLaren P1", id: "list-09" },
    { text: "Ferrari LaFerrari", id: "list-10" }
  ];
  const [state, SetState] = React.useState({
    eventData: [],
  });
  function btnClick() {
    SetState({
      eventData: []
    });
  }
  //Handler for actionBegin event trace
  function onActionBegin() {
    setTimeout(() => {
      SetState({
        eventData: [...state.eventData, "actionBegin"]
      });
    }, 0);
  }
  //Handler for select event trace
  function onSelect(args) {
    SetState({
      eventData: [...state.eventData, `${args.text} is selected`]
    });
  }
  //Handler for actionComplete event trace
  function onActionComplete() {
    setTimeout(() => {
      SetState({
        eventData: [...state.eventData, "actionComplete"]
      });
    }, 0);
  }
  return (<div id="sample">
    <div className="content-wrapper">
      <ListViewComponent id="listview-def" dataSource={data} width="250" select={onSelect.bind(this)} actionBegin={onActionBegin.bind(this)} actionComplete={onActionComplete.bind(this)} />
    </div>
    <div id="list_event">
      <h4>
        <b>Event Trace</b>
      </h4>
      <div id="evt">
        <div className="eventarea">
          {/*Event log element */}
          <span className="EventLog" id="EventLog">
            <div />
            {state.eventData.map((data, index) => (<div key={index}>{data}</div>))}
          </span>
        </div>
        <div className="evtbtn">
          {/*clear button element */}
          <ButtonComponent id="clear" onClick={btnClick.bind(this)}>
            Clear
          </ButtonComponent>
        </div>
      </div>
    </div>
  </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';


function App() {
  //Define an array of JSON data
  let data: any[] = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" },
    { text: "Aston Martin One- 77", id: "list-07" },
    { text: "Jaguar XJ220", id: "list-08" },
    { text: "McLaren P1", id: "list-09" },
    { text: "Ferrari LaFerrari", id: "list-10" }
  ];
  const [state, SetState] = React.useState({
    eventData: [],
  });
  function btnClick() {
    SetState({
      eventData: []
    });
  }

  //Handler for actionBegin event trace
  function onActionBegin(): void {
    setTimeout(() => {
      SetState({
        eventData: [...state.eventData, "actionBegin"]
      });
    }, 0);
  }

  //Handler for select event trace
  function onSelect(args: SelectEventArgs): void {
    SetState({
      eventData: [...state.eventData, `${args.text} is selected`]
    });
  }

  //Handler for actionComplete event trace
  function onActionComplete(): void {
    setTimeout(() => {
      SetState({
        eventData: [...state.eventData, "actionComplete"]
      });
    }, 0);
  }

  return (
    <div id="sample">
      <div className="content-wrapper">
        <ListViewComponent
          id="listview-def"
          dataSource={data}
          width="250"
          select={onSelect.bind(this) as any}
          actionBegin={onActionBegin.bind(this) as any}
          actionComplete={onActionComplete.bind(this) as any}
        />
      </div>
      <div id="list_event">
        <h4>
          <b>Event Trace</b>
        </h4>
        <div id="evt">
          <div className="eventarea">
            {/*Event log element */}
            <span className="EventLog" id="EventLog">
              <div />
              {state.eventData.map((data: string, index: number) => (
                <div key={index}>{data}</div>
              ))}
            </span>
          </div>
          <div className="evtbtn">
            {/*clear button element */}
            <ButtonComponent id="clear" onClick={btnClick.bind(this)}>
              Clear
            </ButtonComponent>
          </div>
        </div>
      </div>
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
.content-wrapper {
  padding-left: 40px;
  padding-top: 36px;
}

#EventLog b {
  color: #388e3c;
}

#EventLog {
  word-break: normal
}

#listview-def {
  border: 1px solid #dcdcdc;
}

.evtbtn {
  margin-top: 40px;
  margin-left: 70px;
}

/* csslint ignore:start */

hr {
  margin-top: 6px !important;
  margin-bottom: 6px !important;
}

/* csslint ignore:end */

#evt {
  border: 1px solid #dcdcdc;
  padding: 10px;
  min-width: 10px;
}

#sample {
  display: inline-flex;
}

.eventarea {
  min-width: 250px;
  height: 273px;
  overflow: auto
}

#list_event {
  margin-top: -25px;
  padding-left: 40px;
  min-width: 200px;
}

#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-react-lists/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-react-buttons/styles/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='element' style="max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Event Tracing in Angular ListView Component

10 Sep 20257 minutes to read

The ListView component provides built-in events that can be used as extension points to implement custom operations and debugging. This guide demonstrates how to trace and handle various ListView events effectively.

Refer to the following steps to trace the ListView events:

  1. Render the ListView with dataSource, and bind the actionBegin, actionComplete, and select events.

  2. Perform custom operations in actionBegin, actionComplete, and select events.

  3. Provide event log details for actionBegin and actionComplete events, and they will be displayed in the event trace panel when the ListView action starts and the dataSource bound successfully.

  4. Get the selected item details from the SelectEventArgs in the select event, and display the selected list item text in the event trace panel while selecting list items.

  5. Use clear button to remove event trace information.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ListViewModule } from '@syncfusion/ej2-angular-lists'
import { Component, ViewChild, ViewEncapsulation } from "@angular/core";
import { SelectEventArgs } from "@syncfusion/ej2-lists";
@Component({
  imports: [
    ListViewModule
  ],
  standalone: true,
  selector: 'my-app',
  template: `<div id="sample">
      <div class="content-wrapper">
    <ejs-listview id='listview-def' [dataSource]='listData' [width]='250' (select)='onSelect($event)' (actionBegin)='onActionBegin($event)' (actionComplete)='onActionComplete($event)'></ejs-listview>
         </div>
         <div id="list_event">
                <h4><b>Event Trace</b></h4>
                <div id="evt">
                    <div class="eventarea" style="height:273px;overflow: auto">
                        <span #EventLog class="EventLog" id="EventLog" style="word-break: normal;"></span>
                    </div>
                    <div class="evtbtn">
                        <input ejs-button id="clear" type="button" value="Clear" (click)='onclick($event)'>
                    </div>
                </div>
            </div>
        </div>`,
  styles: [`
      #EventLog b {
        color: #388e3c;
      }

      #listview-def {
        border: 1px solid #dcdcdc;
      }
      .content-wrapper {
        padding-left: 40px;
        padding-top: 36px;
      }

      .evtbtn {
        margin-top: 40px;
        margin-left: 70px;
      }

      /* csslint ignore:start */

      hr {
        margin-top: 6px !important;
        margin-bottom: 6px !important;
      }

      /* csslint ignore:end */

      #evt {
        border: 1px solid #dcdcdc;
        padding: 10px;
        min-width: 10px;
      }

      #sample {
        display: inline-flex;
      }

      .eventarea {
        min-width: 250px;
      }

      #list_event {
        margin-top: -25px;
        padding-left:40px;
        min-width: 200px;
      }
        `],
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild('EventLog') EventLogEle: any;
  public listData: Object = [
    { text: "Hennessey Venom", id: "list-01" },
    { text: "Bugatti Chiron", id: "list-02" },
    { text: "Bugatti Veyron Super Sport", id: "list-03" },
    { text: "SSC Ultimate Aero", id: "list-04" },
    { text: "Koenigsegg CCR", id: "list-05" },
    { text: "McLaren F1", id: "list-06" },
    { text: "Aston Martin One- 77", id: "list-07" },
    { text: "Jaguar XJ220", id: "list-08" },
    { text: "McLaren P1", id: "list-09" },
    { text: "Ferrari LaFerrari", id: "list-10" }
  ];
  onclick(event: any) {
    this.EventLogEle.nativeElement.innerHTML = "";
  }
  onSelect(args: SelectEventArgs) {
    this.appendElement(args.text + "<b>&nbsp;&nbsp;is selected</b><hr>");
  }
  onActionBegin(args: any) {
    this.appendElement("<b>actionBegin </b> event is triggered<hr>");
  }
  onActionComplete(args: any) {
    this.appendElement("<b>actionComplete</b> is triggered <hr>");
  }
  appendElement(html: string): void {
    let span: HTMLElement = document.createElement("span");
    span.innerHTML = html;
    let log: HTMLElement = this.EventLogEle.nativeElement;
    log.insertBefore(span, log.firstChild);
  }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-lists/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-popups/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-inputs/styles/material.css';

#sample-list {
    display: block;
    max-width: 400px;
    margin: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Trace all events in ListView in Vue ListView component

21 Feb 202510 minutes to read

The ListView component triggers events based on its actions. The events can be used as extension points to perform custom operations. Refer to the following steps to trace the ListView events:

  1. Render the ListView with dataSource, and bind the actionBegin, actionComplete, and select events.

  2. Perform custom operations in actionBegin, actionComplete, and select events.

  3. Provide event log details for actionBegin and actionComplete events, and they will be displayed in the event trace panel when the ListView action starts and the dataSource is bound successfully.

  4. Get the selected item details from the SelectEventArgs in the select event, and display the selected list item text in the event trace panel while selecting list items.

  5. Use the clear button to remove event trace information.

<template>
  <div id="sample">
    <div class="content-wrapper">
      <!-- ListView element -->
      <ejs-listview id='listview-def' ref='listviewInstance' :dataSource='data' width=250 :actionBegin='onBegin'
        :actionComplete='onComplete' :select='onSelect'>
      </ejs-listview>
    </div>
    <div id="list_event">
      <h4><b>Event Trace</b></h4>
      <div id="evt">
        <div class="eventarea" style="height:273px;overflow: auto">
          <span ref='EventLogEle' class="EventLog" id="EventLog" style="word-break: normal;"></span>
        </div>
        <div class="evtbtn">
          <ejs-button id="clear" @click='onClick'>Clear</ejs-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>

import { ListViewComponent as EjsListview } from "@syncfusion/ej2-vue-lists";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
import { ref } from 'vue';

const EventLogEle = ref(null);

const data = [
  { text: "Hennessey Venom", id: "list-01" },
  { text: "Bugatti Chiron", id: "list-02" },
  { text: "Bugatti Veyron Super Sport", id: "list-03" },
  { text: "SSC Ultimate Aero", id: "list-04" },
  { text: "Koenigsegg CCR", id: "list-05" },
  { text: "McLaren F1", id: "list-06" },
  { text: "Aston Martin One- 77", id: "list-07" },
  { text: "Jaguar XJ220", id: "list-08" },
  { text: "McLaren P1", id: "list-09" },
  { text: "Ferrari LaFerrari", id: "list-10" }
]


const onBegin = () => {
  appendElement("<b>actionBegin </b> event is triggered<hr>");
};
const onComplete = () => {
  appendElement("<b>actionComplete</b> is triggered <hr>");
};
const onSelect = (args) => {
  appendElement(args.text + "<b>&nbsp;&nbsp;is selected</b><hr>");
};
const appendElement = (html) => {
  let span = document.createElement("span");
  span.innerHTML = html;
  let log = EventLogEle.value;
  log.insertBefore(span, log.firstChild);
};
const onClick = () => {
  EventLogEle.value.innerHTML = "";
};

</script>
<style>
#EventLog b {
  color: #388e3c;
}

#listview-def {
  border: 1px solid #dcdcdc;
}

.content-wrapper {
  padding-left: 40px;
  padding-top: 36px;
}

.evtbtn {
  margin-top: 40px;
  margin-left: 70px;
}

/* csslint ignore:start */

hr {
  margin-top: 6px !important;
  margin-bottom: 6px !important;
}

/* csslint ignore:end */

#evt {
  border: 1px solid #dcdcdc;
  padding: 10px;
  min-width: 10px;
}

#sample {
  display: inline-flex;
}

.eventarea {
  min-width: 250px;
}

#list_event {
  margin-top: -25px;
  padding-left: 40px;
  min-width: 200px;
}
</style>
<template>
  <div id="sample">
    <div class="content-wrapper">
      <!-- ListView element -->
      <ejs-listview id='listview-def' ref='listviewInstance' :dataSource='data' width=250 :actionBegin='onBegin'
        :actionComplete='onComplete' :select='onSelect'>
      </ejs-listview>
    </div>
    <div id="list_event">
      <h4><b>Event Trace</b></h4>
      <div id="evt">
        <div class="eventarea" style="height:273px;overflow: auto">
          <span ref='EventLogEle' class="EventLog" id="EventLog" style="word-break: normal;"></span>
        </div>
        <div class="evtbtn">
          <ejs-button id="clear" @click.native='onClick'>Clear</ejs-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>

import { ListViewComponent } from "@syncfusion/ej2-vue-lists";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";



export default {
  name: "App",
  components: {
    "ejs-listview": ListViewComponent,
    "ejs-button": ButtonComponent
  },

  data: function () {
    return {
      data: [
        { text: "Hennessey Venom", id: "list-01" },
        { text: "Bugatti Chiron", id: "list-02" },
        { text: "Bugatti Veyron Super Sport", id: "list-03" },
        { text: "SSC Ultimate Aero", id: "list-04" },
        { text: "Koenigsegg CCR", id: "list-05" },
        { text: "McLaren F1", id: "list-06" },
        { text: "Aston Martin One- 77", id: "list-07" },
        { text: "Jaguar XJ220", id: "list-08" },
        { text: "McLaren P1", id: "list-09" },
        { text: "Ferrari LaFerrari", id: "list-10" }
      ]
    };
  },
  methods: {
    onBegin: function () {
      this.appendElement("<b>actionBegin </b> event is triggered<hr>");
    },
    onComplete: function () {
      this.appendElement("<b>actionComplete</b> is triggered <hr>");
    },
    onSelect: function (args) {
      this.appendElement(args.text + "<b>&nbsp;&nbsp;is selected</b><hr>");
    },
    appendElement: function (html) {
      let span = document.createElement("span");
      span.innerHTML = html;
      let log = this.$refs.EventLogEle;
      log.insertBefore(span, log.firstChild);
    },
    onClick: function () {
      this.$refs.EventLogEle.innerHTML = "";
    }
  }
}
</script>
<style>
#EventLog b {
  color: #388e3c;
}

#listview-def {
  border: 1px solid #dcdcdc;
}

.content-wrapper {
  padding-left: 40px;
  padding-top: 36px;
}

.evtbtn {
  margin-top: 40px;
  margin-left: 70px;
}

/* csslint ignore:start */

hr {
  margin-top: 6px !important;
  margin-bottom: 6px !important;
}

/* csslint ignore:end */

#evt {
  border: 1px solid #dcdcdc;
  padding: 10px;
  min-width: 10px;
}

#sample {
  display: inline-flex;
}

.eventarea {
  min-width: 250px;
}

#list_event {
  margin-top: -25px;
  padding-left: 40px;
  min-width: 200px;
}
</style>